/*globals jQuery */

jQuery(document).ready(function () {
	// Uploading files
	var file_frame;
	var wp_media_post_id = wp.media.model.settings.post.id; // Store the old id

	var set_to_post_id = jQuery('#watermark').val(); // Set this

	var watermark_preview = jQuery('.watermark_preview');
	var watermark_remove = jQuery('.watermark_remove');
	var watermark_updated_message = jQuery('.watermark_updated_message');

	if(!set_to_post_id) {
		watermark_preview.hide();
		watermark_remove.hide();
	}
	watermark_updated_message.hide();

	jQuery('.otgs_fg_upload_image_button').live('click', function (event) {

		event.preventDefault();

		watermark_preview.hide();

		// If the media frame already exists, reopen it.
		if (file_frame) {
			// Set the post ID to what we want
			file_frame.uploader.uploader.param('post_id', set_to_post_id);
			// Open frame
			file_frame.open();
			return;
		} else {
			// Set the wp.media post id so the uploader grabs the ID we want when initialised
			wp.media.model.settings.post.id = set_to_post_id;
		}

		// Create the media frame.
		file_frame = wp.media.frames.file_frame = wp.media({
			title:    jQuery(this).data('uploader_title'),
			button:   {
				text: jQuery(this).data('uploader_button_text')
			},
			multiple: false  // Set to true to allow multiple files to be selected
		});

		// When an image is selected, run a callback.
		file_frame.on('select', function () {
			// We set multiple to false so only get one image from the uploader
			var attachment = file_frame.state().get('selection').first().toJSON();

			// Do something with attachment.id and/or attachment.url here
			watermark_preview.find('img').attr('src', attachment.url);
			watermark_preview.show();
			watermark_remove.show();
			jQuery('#watermark').val(attachment.id);
			watermark_updated_message.show();

			// Restore the main post ID
			wp.media.model.settings.post.id = wp_media_post_id;
		});

		// Finally, open the modal
		file_frame.open();
	});


	watermark_remove.live('click', function (event) {
		event.preventDefault();

		jQuery('#watermark').val(false);
		watermark_preview.find('img').attr('src', '');
		watermark_preview.hide();
		watermark_remove.hide();
		watermark_updated_message.show();
		wp.media.model.settings.post.id = false;
	});

	// Restore the main ID when the add media button is pressed
	jQuery('a.add_media').on('click', function () {
		wp.media.model.settings.post.id = wp_media_post_id;
	});
});